#include <avr/io.h>
#include <avr/interrupt.h> 

#define X_MIN			3500	// <
#define X_MIN_CENTER	4500
#define X_CENTER		5500
#define X_MAX_CENTER	6500
#define X_MAX			7500	// >

#define Y_MIN			3500	// v
#define Y_MIN_CENTER	4500
#define Y_CENTER		5500
#define Y_MAX_CENTER	6500
#define Y_MAX			7500	// ^

#define START			0
#define STEPS			104

uint8_t servo=4;
unsigned volatile long int
timer_c=1,
servo_c=START,
x_pos[]=
{
X_CENTER,			// Init
X_CENTER,			// Ready
X_CENTER,			
X_CENTER,			
X_CENTER,			
X_CENTER,			
X_CENTER,			
X_MIN,				// Set
X_MIN,		
X_MIN,		
X_MIN,		
X_MIN,		
X_MIN,		
X_MIN,		
X_MIN,		
X_MAX,				// Start
X_MAX,				
X_MAX,				
X_MAX,				
X_MAX,				// 1 2
X_MAX,				
X_MAX,				
X_MIN,				
X_MIN,				
X_MIN,				
X_MIN,				
X_MIN,				
X_MAX_CENTER+100,	// 3 4 5
X_MAX,				
X_MAX,				
X_MAX,				
X_MAX,				
X_MAX,				
X_MIN,				//
X_MIN,				
X_MIN,				
X_MIN,				
X_MAX,				
X_MAX_CENTER,
X_MAX_CENTER,
X_MAX_CENTER,
X_MAX_CENTER,
X_MAX_CENTER,
X_MIN+200,			// 6	
X_MIN+200,				
X_CENTER+200,		// 7 8 9 10	
X_CENTER+300,			
X_CENTER+300,			
X_MAX_CENTER,		
X_MAX_CENTER,		
X_MAX_CENTER,		
X_MAX_CENTER,
X_MIN,		
X_MIN,		
X_MIN,		
X_MIN,		
X_MIN,
X_MIN,		
X_MIN_CENTER-100,	// 11 12 13
X_MIN_CENTER-100,
X_MIN_CENTER-100,
X_MIN_CENTER-100,
X_MIN_CENTER-100,
X_MIN_CENTER-100,
X_MAX,				// 14 15 16
X_MAX,				
X_MAX,				
X_MAX,				
X_MAX,
X_MAX,
X_MIN_CENTER,		
X_MIN_CENTER,				
X_MIN_CENTER,
X_MIN_CENTER,				
X_MIN_CENTER,				
X_MAX_CENTER+200,	// 17 18 19
X_MAX_CENTER+200,		
X_MAX_CENTER+200,		
X_MAX_CENTER+250,		
X_MAX_CENTER+200,			
X_MAX_CENTER+200,			
X_MAX_CENTER+200,		
X_MAX_CENTER+200,		
X_MAX_CENTER+200,		
X_MAX_CENTER+200,		
X_MAX_CENTER+200,		
X_MAX_CENTER+200,		
X_MAX_CENTER+200,		
X_MIN_CENTER+700,	// 20 21 22
X_MIN_CENTER+700,		
X_MIN_CENTER+700,		
X_MIN,
X_MIN,		
X_MAX,				// 23 24
X_MAX,
X_MAX,
X_MAX,
X_MIN,				
X_MIN,				// 25 26 27
X_MIN,
X_MIN,
X_MIN,
X_MIN,
X_MIN,
X_MAX,				// 28 29 30
},
y_pos[]=
{
Y_CENTER,			// Init
Y_CENTER,			// Ready
Y_CENTER,	
Y_CENTER,
Y_CENTER,
Y_CENTER,
Y_CENTER,
Y_MIN,				// Set
Y_MIN,
Y_MIN,
Y_MIN,
Y_MIN,
Y_MIN,
Y_MIN,
Y_MIN,
Y_MIN,				// Start
Y_MIN,
Y_MIN,
Y_MIN,
Y_MAX,				// 1 2
Y_MAX,
Y_MIN,
Y_MIN,
Y_MIN,
Y_MIN,
Y_MIN,
Y_MIN,
Y_CENTER,			// 3 4 5
Y_MAX_CENTER+700,
Y_MAX_CENTER+700,
Y_MAX_CENTER+700,
Y_MAX_CENTER+700,
Y_MAX_CENTER+700,
Y_MAX,				//
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_CENTER,
Y_MIN_CENTER,
Y_MIN_CENTER,
Y_MIN_CENTER,
Y_MIN_CENTER,
Y_MAX,				// 6
Y_MAX,
Y_MAX,				// 7 8 9 10
Y_MAX,				
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_MAX,
Y_MIN_CENTER,		// 11 12 13
Y_MIN_CENTER,
Y_MIN_CENTER,
Y_MIN_CENTER,
Y_MIN_CENTER,
Y_CENTER-500,
Y_CENTER-500,		// 14 15 16
Y_CENTER,
Y_CENTER,
Y_CENTER-100,
Y_CENTER-100,		
Y_CENTER-100,
Y_CENTER-100,
Y_CENTER-100,
Y_CENTER-100,
Y_CENTER-100,
Y_CENTER-100,
Y_MIN_CENTER,		// 17 18 19
Y_MIN_CENTER,
Y_MIN_CENTER,
Y_MIN_CENTER,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_CENTER-50,
Y_MIN_CENTER,		// 20 21 22
Y_MAX-500,
Y_MAX-500,
Y_MAX-500,
Y_MAX-500,
Y_MAX-500,			// 23 24
Y_MAX_CENTER,		
Y_MAX_CENTER,
Y_MAX_CENTER,
Y_MAX_CENTER,
Y_MAX_CENTER,		// 25 26 27
Y_MAX_CENTER,
Y_MAX_CENTER,
Y_MAX_CENTER,
Y_MAX_CENTER,
Y_MAX_CENTER,
Y_MIN,				// 28 29 30
};

void PWM_Init(void);
void Output_Init(void);
void Switch_Init(void);

int main(void)
{
	sei();
	PWM_Init();
	Output_Init();

	for(;;)
	{
		if(!(PIND & (1 << 2)))
		{
			DDRA &= ~(1 << 4);
			DDRA &= ~(1 << 5);
		}
	}
	
	return 0;
}

void PWM_Init(void)
{
	// Fast PWM (TOP value is ICR1)
	// Clear OC1A/OC1B on compare match
	// Prescaler 1
	TCCR1A |= _BV(WGM11) | _BV(COM1A1);
	TCCR1B |= _BV(WGM12) | _BV(WGM13) | _BV(CS10);
	//Output Compare and Overflow 1B Interrupt Enable
	TIMSK |= (1<<OCIE1A) | (1<<TOIE1);	
	// TOP = (fCLK / (fPWM * 2 * N)) - 1
	ICR1 = 39999; //50Hz		   
}

void Output_Init(void)
{
	DDRA |= (1 << 4);	// Servo #2 Y axis
	DDRA |= (1 << 5);	// Servo #1 X axis
}

void Switch_Init(void)
{
	DDRD &= ~(1 << 2);
	PORTD |= (1 << 2);
}

ISR(TIMER1_COMPA_vect){
	PORTA &= ~(1 << servo);

	if(timer_c%25==1)
	{
		if(servo_c<STEPS) servo_c++;
	}
	timer_c++;

	if(servo==4)
	{
		/////// Servo #1 X axis 
		OCR1A = x_pos[servo_c];
		servo=5;
	}
	else
	{
		/////// Servo #2 Y axis
		OCR1A = y_pos[servo_c];
		servo=4;
	}
}

ISR(TIMER1_OVF_vect){
	PORTA |= (1 << servo);
} 
